local playername = UnitName("player")
local lootitemstring = string.gsub(LOOT_ITEM, "%%s", "(.+)")
local lootitemmultiplestring = string.gsub(LOOT_ITEM_MULTIPLE, "%%s", "(.+)")
local lootitemselfstring = string.gsub(LOOT_ITEM_SELF, "%%s", "(.+)")
local lootitemselfmultiplestring = string.gsub(LOOT_ITEM_SELF_MULTIPLE, "%%s", "(.+)")

BadgeWatch = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0")

local mod = BadgeWatch

local BadgeList = {}
local IsTracking = false

function mod:OnEnable()
	self:RegisterEvent("CHAT_MSG_LOOT")
end

function mod:CHAT_MSG_LOOT(msg)
	if not IsInInstance() then return end

	local looter, item
	looter, item = select(3, string.find(msg, lootitemstring))
	if not looter or not item then
		looter, item = select(3, string.find(msg, lootitemmultiplestring))
	end

	if not looter or not item then
		item = select(3, string.find(msg, lootitemselfstring))
		if item then
			looter = playername
		else
			item = select(3, string.find(msg, lootitemselfmultiplestring))
			if item then
				looter = playername
			end
		end
	end

	if type(item) ~= "string" or type(name) ~= "string" then return end
	local itemid = select(2, GetItemInfo(item)):match("item:(%d+)")
	if tonumber(itemid) ~= 29434 then return end

	-- First badge looted, fill the BadgeList
	if not IsTracking then
		BadgeList[playername] = false
		for i = 1, GetNumRaidMembers() do
			local name,_,group = GetRaidRosterInfo(i)
			if name and (group < 6) then
				BadgeList[name] = false
			end
		end
		for i = 1, GetNumPartyMembers() do
			local name = UnitName("party"..i)
			if name then
				BadgeList[name] = false
			end
		end
		IsTracking = true
	end

	self:ScheduleEvent("BadgeWatchCheck", self.CheckLoot, 2*60, self)
	self:ScheduleEvent("BadgeWatchReset", self.ResetTracking, 6*60, self)

	BadgeList[looter] = true
end

function mod:CheckLoot()
	for name, hasLooted in pairs(BadgeList) do
		if not hasLooted then
			SendChatMessage("You forgot to loot your badges!", "WHISPER", nil, name)
		end
	end
end

function mod:ResetTracking()
	BadgeList = {}
	IsTracking = false
end
